local MountMacro, mm = ...
local _G = getfenv(0)

-- mm.L = _G.setmetatable({}, {__index=function(t,i) return i end})

-- local L = mm.L

-- L["Enable %s"] 																				= true
-- L["Enables / disables the addon"]														= true
-- L["Random Weight"]																			= true
-- L["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."]
-- 																									= true
-- L["Macro Template"]																			= true
-- L["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."]				
-- 																									= true
-- L["Reset Macro Template"]																	= true
-- L["Reset the macro to the default value."]											= true
-- L["Refresh Macro"]																			= true
-- L["Regenerate the macro based on the current template."]							= true
-- L["Resulting macro"]																			= true

local _G           = getfenv(0)
local pairs        = _G.pairs
local print        = _G.print
local rawget       = _G.rawget
local rawset       = _G.rawset
local setmetatable = _G.setmetatable
local sort         = _G.sort
local table        = _G.table

local function err(msg,...) _G.geterrorhandler()(msg:format(_G.tostringall(...)) .. " - " .. _G.time()) end

-- Code borrowed from Tekkub
local localized
local loc = _G.GetLocale()

-----------------------
--      English      --
-----------------------

-- The english table is not actually used for translation, just to validate that all the phares are listed on the WoWAce site.
local english = {}
local L = english -- Needs to be L[] in order to paste on the WoWAce site

L[ "Enable %s" ]                                                                                                                                          = true
L[ "Enables / disables the addon" ]                                                                                                                       = true
L[ "Macro Template" ]                                                                                                                                     = true
L[ "Random Weight for Class Mounts" ]                                                                                                                     = true
L[ "Random Weight for Non Favorite" ]                                                                                                                     = true
L[ "Refresh Macro" ]                                                                                                                                      = true
L[ "Regenerate the macro based on the current template." ]                                                                                                = true
L[ "Reset Macro Template" ]                                                                                                                               = true
L[ "Reset the macro to the default value." ]                                                                                                              = true
L[ "Resulting macro" ]                                                                                                                                    = true
L[ "Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons." ]                                          = true
L[ "Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected." ]                     = true
L[ "Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100." ] = true

----------------------
--      French      --
----------------------

if loc == "frFR" then

localized = {}
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

----------------------
--      German      --
----------------------

if loc == "deDE" then

localized = {}
localized["Enable %s"] = "%s aktivieren"
localized["Enables / disables the addon"] = "Aktiviert/Deaktiviert das Addon"
localized["Macro Template"] = "Makrovorlage"
localized["Random Weight for Class Mounts"] = "Zufallsgewichtung für Klassenreittiere"
localized["Random Weight for Non Favorite"] = "Zufallsgewichtung für Nicht-Favoriten"
localized["Refresh Macro"] = "Makro erneuern"
localized["Regenerate the macro based on the current template."] = "Erzeugt das Makro basierend auf der momentanen Vorlage erneut."
localized["Reset Macro Template"] = "Makrovorlage zurücksetzen"
localized["Reset the macro to the default value."] = "Das Makro auf den Standardwert zurücksetzen."
localized["Resulting macro"] = "Resultierendes Makro"
localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = "Vorlage, die verwendet wird, um das charakterspezifische Makro namens mm zu erstellen. Öffne das Makromenü (z.B. per /makro) und ziehe das Makro in deine Aktionsleiste."
localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = "Gewichtung für die Klassenreittiere wie das Schreckensross der Hexenmeister; von 0 bis 100. Verwende 0, wenn du willst, dass diese Reittiere nicht ausgewählt werden."
localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = "Gewichtung für nicht favorisierte Reittiere; von 0 bis 100. Verwende 0, wenn du willst, dass nur favorisierte Reittiere ausgewählt werden. Favorisierte Reittiere haben eine Gewichtung von 100."


end

----------------------
--      Spanish     --
----------------------

if loc == "esES" then

localized = {}
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

----------------------------
-- Latin American Spanish --
----------------------------

if loc == "esMX" then

localized = {}
-- Little hack to use esES translation if a phrase doesn't exist in esMX
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""

-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

----------------------
--      Rusian      --
----------------------

if loc == "ruRU" then

localized = {}
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

----------------------
--      Korean      --
----------------------

if loc == "koKR" then

localized = {}
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

------------------------
-- Simplified Chinese --
------------------------

if loc == "zhCN" then

localized = {}
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

-------------------------
-- Traditional Chinese --
-------------------------

if loc == "zhTW" then

localized = {}
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end


-- Metatable majicks... makes localized table fallback to english, or fallback to the index requested.
-- This ensures we ALWAYS get a value back, even if it's the index we requested originally
mm.L = localized and setmetatable(localized, {__index = function(t,i) return english[i] ~= true and english[i] or i end})
	or setmetatable({}, {__index = function(t,i)
		-- Get the error only the first time a missing string is found
		if rawget(english, i) ~= true then
			rawset(english, i, true)
			rawset(t, i, i)
			err("Missing translation: %s",i)
		end
		return i 
end})

function mm:DumpLocales()
	local t = {}
	for k in pairs(english) do table.insert(t,k) end
	sort(t)
	for i=1,#t do
		print(("L[ \"%s\" ] = true"):format(t[i]:gsub('\\','\\\\'):gsub('"','\\"')))
	end
end
